LOCAL_PATH := $(call my-dir)

###########################
#
# Tcl shared library
#
###########################

include $(CLEAR_VARS)

LOCAL_MODULE := tcl

LOCAL_C_INCLUDES := $(LOCAL_PATH)/generic \
	$(LOCAL_PATH)/unix \
	$(LOCAL_PATH)/libtommath

LOCAL_EXPORT_C_INCLUDES := $(LOCAL_C_INCLUDES)

LOCAL_SRC_FILES := \
        libtommath/bncore.c \
        libtommath/bn_reverse.c \
        libtommath/bn_fast_s_mp_mul_digs.c \
        libtommath/bn_fast_s_mp_sqr.c \
        libtommath/bn_mp_add.c \
        libtommath/bn_mp_add_d.c \
        libtommath/bn_mp_and.c \
        libtommath/bn_mp_clamp.c \
        libtommath/bn_mp_clear.c \
        libtommath/bn_mp_clear_multi.c \
        libtommath/bn_mp_cmp.c \
        libtommath/bn_mp_cmp_d.c \
        libtommath/bn_mp_cmp_mag.c \
        libtommath/bn_mp_copy.c \
        libtommath/bn_mp_cnt_lsb.c \
        libtommath/bn_mp_count_bits.c \
        libtommath/bn_mp_div.c \
        libtommath/bn_mp_div_d.c \
        libtommath/bn_mp_div_2.c \
        libtommath/bn_mp_div_2d.c \
        libtommath/bn_mp_div_3.c \
        libtommath/bn_mp_exch.c \
        libtommath/bn_mp_expt_d.c \
        libtommath/bn_mp_grow.c \
        libtommath/bn_mp_init.c \
        libtommath/bn_mp_init_copy.c \
        libtommath/bn_mp_init_multi.c \
        libtommath/bn_mp_init_set.c \
        libtommath/bn_mp_init_set_int.c \
        libtommath/bn_mp_init_size.c \
        libtommath/bn_mp_karatsuba_mul.c \
        libtommath/bn_mp_karatsuba_sqr.c \
        libtommath/bn_mp_lshd.c \
        libtommath/bn_mp_mod.c \
        libtommath/bn_mp_mod_2d.c \
        libtommath/bn_mp_mul.c \
        libtommath/bn_mp_mul_2.c \
        libtommath/bn_mp_mul_2d.c \
        libtommath/bn_mp_mul_d.c \
        libtommath/bn_mp_neg.c \
        libtommath/bn_mp_or.c \
        libtommath/bn_mp_radix_size.c \
        libtommath/bn_mp_radix_smap.c \
        libtommath/bn_mp_read_radix.c \
        libtommath/bn_mp_rshd.c \
        libtommath/bn_mp_set.c \
        libtommath/bn_mp_set_int.c \
        libtommath/bn_mp_shrink.c \
        libtommath/bn_mp_sqr.c \
        libtommath/bn_mp_sqrt.c \
        libtommath/bn_mp_sub.c \
        libtommath/bn_mp_sub_d.c \
        libtommath/bn_mp_to_unsigned_bin.c \
        libtommath/bn_mp_to_unsigned_bin_n.c \
        libtommath/bn_mp_toom_mul.c \
        libtommath/bn_mp_toom_sqr.c \
        libtommath/bn_mp_toradix_n.c \
        libtommath/bn_mp_unsigned_bin_size.c \
        libtommath/bn_mp_xor.c \
        libtommath/bn_mp_zero.c \
        libtommath/bn_s_mp_add.c \
        libtommath/bn_s_mp_mul_digs.c \
        libtommath/bn_s_mp_sqr.c \
        libtommath/bn_s_mp_sub.c \
        generic/regcomp.c \
        generic/regexec.c \
        generic/regfree.c \
        generic/regerror.c \
        generic/tclAlloc.c \
        generic/tclAssembly.c \
        generic/tclAsync.c \
        generic/tclBasic.c \
        generic/tclBinary.c \
        generic/tclCkalloc.c \
        generic/tclClock.c \
        generic/tclCmdAH.c \
        generic/tclCmdIL.c \
        generic/tclCmdMZ.c \
        generic/tclCompCmds.c \
        generic/tclCompCmdsGR.c \
        generic/tclCompCmdsSZ.c \
        generic/tclCompExpr.c \
        generic/tclCompile.c \
        generic/tclConfig.c \
        generic/tclDate.c \
        generic/tclDictObj.c \
        generic/tclEncoding.c \
        generic/tclEnsemble.c \
        generic/tclEnv.c \
        generic/tclEvent.c \
        generic/tclExecute.c \
        generic/tclFCmd.c \
        generic/tclFileName.c \
        generic/tclGet.c \
        generic/tclHash.c \
        generic/tclHistory.c \
        generic/tclIndexObj.c \
        generic/tclInterp.c \
        generic/tclIO.c \
        generic/tclIOCmd.c \
        generic/tclIOGT.c \
        generic/tclIOSock.c \
        generic/tclIOUtil.c \
        generic/tclIORChan.c \
        generic/tclIORTrans.c \
        generic/tclLink.c \
        generic/tclListObj.c \
        generic/tclLiteral.c \
        generic/tclLoad.c \
        generic/tclMain.c \
        generic/tclNamesp.c \
        generic/tclNotify.c \
        generic/tclObj.c \
        generic/tclOptimize.c \
        generic/tclPanic.c \
        generic/tclParse.c \
        generic/tclPathObj.c \
        generic/tclPipe.c \
        generic/tclPkg.c \
        generic/tclPkgConfig.c \
        generic/tclPosixStr.c \
        generic/tclPreserve.c \
        generic/tclProc.c \
        generic/tclRegexp.c \
        generic/tclResolve.c \
        generic/tclResult.c \
        generic/tclScan.c \
        generic/tclStubInit.c \
        generic/tclStringObj.c \
        generic/tclStrToD.c \
        generic/tclThread.c \
        generic/tclThreadAlloc.c \
        generic/tclThreadJoin.c \
        generic/tclThreadStorage.c \
        generic/tclTimer.c \
        generic/tclTomMathInterface.c \
        generic/tclTrace.c \
        generic/tclUtil.c \
        generic/tclUtf.c \
        generic/tclVar.c \
        generic/tclZlib.c \
        generic/tclOO.c \
        generic/tclOOBasic.c \
        generic/tclOOCall.c \
        generic/tclOODefineCmds.c \
        generic/tclOOInfo.c \
        generic/tclOOMethod.c \
        generic/tclOOStubInit.c \
        generic/tclStubLib.c \
        generic/tclTomMathStubLib.c \
        generic/tclOOStubLib.c \
        generic/zipfs.c \
        unix/tclAppInit.c \
        unix/tclLoadDl.c \
        unix/tclUnixChan.c \
        unix/tclUnixCompat.c \
        unix/tclUnixEvent.c \
        unix/tclUnixFCmd.c \
        unix/tclUnixFile.c \
        unix/tclUnixInit.c \
        unix/tclUnixNotfy.c \
        unix/tclUnixPipe.c \
        unix/tclUnixSock.c \
        unix/tclUnixTest.c \
        unix/tclUnixThrd.c \
        unix/tclUnixTime.c

LOCAL_CFLAGS := \
        -DHAVE_SYS_SELECT_H=1 \
        -DHAVE_LIMITS_H=1 \
        -DHAVE_UNISTD_H=1 \
        -DHAVE_SYS_PARAM_H=1 \
        -D_LARGEFILE64_SOURCE=1 \
        -DTCL_WIDE_INT_TYPE="long long" \
        -DTCL_SHLIB_EXT="\".so\"" \
        -DHAVE_CAST_TO_UNION=1 \
        -DHAVE_GETCWD=1 \
        -DHAVE_OPENDIR=1 \
	-DHAVE_MKSTEMP=1 \
	-DHAVE_MKSTEMPS=1 \
        -DHAVE_STRSTR=1 \
        -DHAVE_STRTOL=1 \
        -DHAVE_STRTOLL=1 \
        -DHAVE_STRTOULL=1 \
        -DHAVE_TMPNAM=1 \
        -DHAVE_WAITPID=1 \
	-DHAVE_STRUCT_ADDRINFO=1 \
	-DHAVE_STRUCT_IN6_ADDR=1 \
	-DHAVE_STRUCT_SOCKADDR_IN6=1 \
	-DHAVE_STRUCT_SOCKADDR_STORAGE=1 \
        -DUSE_TERMIOS=1 \
        -DHAVE_MKTIME=1 \
        -DUSE_INTERP_ERRORLINE=1 \
        -DHAVE_SYS_TIME_H=1 \
        -DTIME_WITH_SYS_TIME=1 \
        -DHAVE_TM_ZONE=1 \
        -DHAVE_GMTIME_R=1 \
        -DHAVE_LOCALTIME_R=1 \
        -DHAVE_TM_GMTOFF=1 \
        -DHAVE_TIMEZONE_VAR=1 \
        -DHAVE_ST_BLKSIZE=1 \
        -DSTDC_HEADERS=1 \
	-DHAVE_INTPTR_T=1 \
	-DHAVE_UINTPTR_T=1 \
	-DHAVE_SIGNED_CHAR=1 \
        -DHAVE_SYS_IOCTL_H=1 \
        -DVOID=void \
        -DNO_UNION_WAIT=1 \
        -DHAVE_ZLIB=1 \
	-DMP_PREC=4 \
	-DTCL_TOMMATH=1 \
	-D_REENTRANT=1 \
	-D_THREADSAFE=1 \
	-DTCL_THREADS=1 \
	-DTCL_PTHREAD_ATFORK=1 \
	-DUSE_THREAD_ALLOC=1 \
	-DTCL_CFGVAL_ENCODING="\"utf-8\"" \
	-DTCL_UNLOAD_DLLS=1 \
	-DTCL_CFG_OPTIMIZED=1 \
        -DZIPFS_IN_TCL=1 \
        -DTCL_PACKAGE_PATH="\"/assets\"" \
        -DTCL_LIBRARY="\"/assets/tcl8.6\"" \
	-DPACKAGE_NAME="\"tcl\"" \
	-DPACKAGE_VERSION="\"8.6\"" \
	-DBUILD_tcl=1 \
        -Dmain=tclsh \
	-O2

LOCAL_LDLIBS := -ldl -lz -llog

include $(BUILD_SHARED_LIBRARY)

