LOCAL_PATH := $(call my-dir)

###########################
#
# tdbc shared library
#
###########################

include $(CLEAR_VARS)

LOCAL_MODULE := tdbc

LOCAL_C_INCLUDES := $(LOCAL_PATH)/../../generic \
	$(LOCAL_PATH)/../../unix \
	$(LOCAL_PATH)/../../libtommath \
	$(LOCAL_PATH)/generic

LOCAL_EXPORT_C_INCLUDES := $(LOCAL_C_INCLUDES)

LOCAL_SRC_FILES := \
	generic/tdbc.c \
	generic/tdbcTokenize.c

LOCAL_CFLAGS += \
        -DHAVE_SYS_SELECT_H=1 \
        -DHAVE_LIMITS_H=1 \
        -DHAVE_UNISTD_H=1 \
        -DHAVE_SYS_PARAM_H=1 \
        -D_LARGEFILE64_SOURCE=1 \
        -DTCL_WIDE_INT_TYPE="long long" \
        -DTCL_SHLIB_EXT="\".so\"" \
        -DHAVE_CAST_TO_UNION=1 \
        -DHAVE_GETCWD=1 \
        -DHAVE_OPENDIR=1 \
	-DHAVE_MKSTEMP=1 \
	-DHAVE_MKSTEMPS=1 \
        -DHAVE_STRSTR=1 \
        -DHAVE_STRTOL=1 \
        -DHAVE_STRTOLL=1 \
        -DHAVE_STRTOULL=1 \
        -DHAVE_TMPNAM=1 \
        -DHAVE_WAITPID=1 \
	-DHAVE_STRUCT_ADDRINFO=1 \
	-DHAVE_STRUCT_IN6_ADDR=1 \
	-DHAVE_STRUCT_SOCKADDR_IN6=1 \
	-DHAVE_STRUCT_SOCKADDR_STORAGE=1 \
        -DUSE_TERMIOS=1 \
        -DHAVE_MKTIME=1 \
        -DUSE_INTERP_ERRORLINE=1 \
        -DHAVE_SYS_TIME_H=1 \
        -DTIME_WITH_SYS_TIME=1 \
        -DHAVE_TM_ZONE=1 \
        -DHAVE_GMTIME_R=1 \
        -DHAVE_LOCALTIME_R=1 \
        -DHAVE_TM_GMTOFF=1 \
        -DHAVE_TIMEZONE_VAR=1 \
        -DHAVE_ST_BLKSIZE=1 \
        -DSTDC_HEADERS=1 \
	-DHAVE_INTPTR_T=1 \
	-DHAVE_UINTPTR_T=1 \
	-DHAVE_SIGNED_CHAR=1 \
        -DHAVE_SYS_IOCTL_H=1 \
        -DVOID=void \
        -DNO_UNION_WAIT=1 \
        -DHAVE_ZLIB=1 \
	-DMP_PREC=4 \
	-DTCL_TOMMATH=1 \
	-D_REENTRANT=1 \
	-D_THREADSAFE=1 \
	-DTCL_THREADS=1 \
	-DUSE_THREAD_ALLOC=1 \
	-DTCL_CFGVAL_ENCODING="\"utf-8\"" \
	-DTCL_UNLOAD_DLLS=1 \
	-DTCL_CFG_OPTIMIZED=1 \
        -DZIPFS_IN_TCL=1 \
        -DTCL_PACKAGE_PATH="\"/assets \"" \
        -DTCL_LIBRARY="\"/assets/tcl8.6\"" \
	-DMODULE_SCOPE="extern __attribute__((__visibility__(\"hidden\")))" \
	-DPACKAGE_NAME="\"tdbc\"" \
	-DPACKAGE_VERSION="\"1.0.0\"" \
	-DBUILD_tdbc=1

LOCAL_SHARED_LIBRARIES := libtcl

LOCAL_LDLIBS :=

include $(BUILD_SHARED_LIBRARY)
